#!/usr/bin/perl
#
# Routine to cd into the appropriate directory, if directory does not exist
# the routine will create the new directory. Routine works with the environment
# variable TEMPDIR to add flexibility of creating directories anywhere.
#
# Programmer:  Terry Williams                Date:  March 4, 1999
#

  use Cwd 'chdir';

  if( $ARGV[0] ) {
    if( $ARGV[0] =~ /-h\b/ ) {
      usage();
      exit();
    }
  }

  $bindir = "$ENV{'BINDIR'}";
  chomp($bindir);
  do ("${bindir}/init.pl");

  if( -d $tmp ) {
    chdir "$tmp";
  } else {
    mkdir( "$tmp", 0777 );
    chdir "$tmp";
  }
  
  mkdir( "$tmp/tmp$$", 0777 );
  chdir "$tmp/tmp$$";
  print "tmpdir = $tmp/tmp$$\n";

  

###########################################################################
sub usage {
  system( "clear" );
  print <<EOS;

mktemp.pl is a routine to create and cd into a randomly numbered directory under
the directory specified in the environment variable TEMPDIR.
  
To execute:

        mktemp.pl
           creates tmp directory and cd to the directory.

        mktemp.pl -h
           provides help on the execution and a brief description

         
EOS

}
