#!/usr/bin/perl
#
# Routine to cd into the appropriate directory, if directory does not exist
# the routine will create the new directory. Routine works with the environment
# variables to add flexibility of creating directories anywhere.  The directory
# type depends upon the argument passed to the routine - data or arc, full.
# data adds to dirname the $DATADIR env 
# tmp adds to dirname the $TMP env
# full takes the complete directory name
#
# Programmer:  Terry Williams                Date:  March 4, 1999
#

  use Cwd 'chdir';

  $bindir = "$ENV{'BINDIR'}";
  chomp($bindir);
  do ("${bindir}/init.pl");


  if( @ARGV ) {
    if( $ARGV[0] =~ /^-h$/ ) {
      usage();
      exit();
    } elsif( $ARGV[0] =~ /-a$/ ) {
      get_params(\$subdir,\$dir_type);
    } else {
      $dir_type = shift;
      $subdir = shift;
      chomp($subdir);
    }
  } else {
    usage();
    exit();
  } 

  if( $dir_type =~ "data" ) {
     $typedir = $datadir;
  } else {
     $typedir = $tmp;
  }

  if( $dir_type =~ "full" ) {
     $fq_subdir = $subdir;
  } else {
     $fq_subdir = sprintf("%s/",$typedir);
     $fq_subdir = $typedir . '/';
     $fq_subdir .= $subdir;
  }


  #print "subdir $fq_subdir \n";

# check for directory existance
  if( -d "$fq_subdir" ) {
    #print "change directory\n";
    chdir "$fq_subdir";

  } else {
    @sdirs = split(m#/#,$fq_subdir);
    foreach (@sdirs) {
      #print "$_\n";
      if( $_ !~ /.+/ ) {
        #print "found blank\n";
        next;
      }
      $new_dir = $new_dir . '/';
      $new_dir = $new_dir . $_;
      #print "new dir = $new_dir \n";
      if( -d $new_dir ) {
        chdir "$new_dir";
        #print "change directory\n";
      } else {
        #print "make directory\n";
        mkdir( "$new_dir",0777);
        # ensure directory has complete permissions for xgrid
        `chmod 777 $new_dir`;
        chdir "$new_dir" ;
      }
    }
  }
  # return new current directory
  print "$ENV{'PWD'}";
  

###########################################################################
sub usage {
  system( "clear" );
  print <<EOS;

setdir.pl is a routine to cd into the appropriate directory, if directory does 
not exist the routine will create the new directory. Routine works with the 
system environment variables to enable creating directories anywhere.
  
To execute:

        setdir.pl  \$subdir  \$type_dir
           creates directory if needed and changes pwd to the directory.  The 
           specified directory is given with next line from STDIN.

        setdir.pl -h
           provides help on the execution and a brief description
         
         
EOS

}
