PROGRAM compute_date
!
!  FORTRAN program to call the date_module from a unix or perl script
!  Routines called are ymd_mjd, mjd_ymd, ymdhms_mjdsec, mjdsec_ymdhms, 
!  mjd_doy, doy_mjd, ymdhms_gpsweek, gpsweek_doy and yrdoy_gpsweek. 
! GETARG is different on the HP and the SUN, on the hp the arg_num's should
! be 2,3,4, respectively.  On the Sun, the arg_num's should be 1,2,3, 
! respectively
!

 USE Date_Time_Module

 IMPLICIT NONE

 INTEGER, PARAMETER :: DP = SELECTED_REAL_KIND(14)

 INTEGER :: YMD,iy,idoy
 INTEGER :: MJD, GPS_Week, YrDoy, Day_of_Week
 INTEGER :: istat 
 INTEGER :: numarg, iargc
 INTEGER :: ihms
 INTEGER, PARAMETER :: arg_num1 = 1
 INTEGER, PARAMETER :: arg_num2 = 2
 INTEGER, PARAMETER :: arg_num3 = 3
 INTEGER, PARAMETER :: arg_num4 = 4
 INTEGER, PARAMETER :: arg_num5 = 5
 REAL(KIND=DP) :: HMS, MJDSEC, FSEC
 REAL(KIND=DP) :: MJDSEC_1, FSEC_1
 REAL(KIND=DP) :: MJDSEC_2, FSEC_2
 REAL(KIND=DP) :: MJDSEC_SUM, FSEC_SUM
 CHARACTER(18) :: arg_str1
 CHARACTER(20)  :: arg_str2, arg_str3, arg_str4, arg_str5
 
!    arg_num is the position of the desired argument in the
!        the command line (the name by which the program
!        was invoked is 0)
!    arg_str is the character array in which the argument
!        will be written
!
! Nice little help added by Mark Torrence
 numarg = iargc()
 if ( numarg .lt. 1 ) then
  write(6,*) 'input args are  ymd_mjd, mjd_ymd, ymdhms_mjdsec,'
  write(6,*) '   mjdsec_ymdhms, ymdhms_mjdsec_fsec, mjdsec_fsec_ymdhms, '
  write(6,*) '   mjdsec_fsec_add, mjd_doy, doy_mjd, ymdhms_gpsweek,'
  write(6,*) '   gpsweek_doy and yrdoy_gpsweek'
  stop
 endif

!write(6,*) " Enter date "
!read *,ymd,hms
 ! read module name
 CALL GETARG(arg_num1, arg_str1)
 
 ! read passed arguments which vary depending on the module called
 CALL GETARG(arg_num2, arg_str2)
 CALL GETARG(arg_num3, arg_str3)
 IF( numarg > 3 ) THEN
    CALL GETARG(arg_num4, arg_str4)
    CALL GETARG(arg_num5, arg_str5)
 END IF

!write(*,*) "arg_str1 arg_str2 ",arg_str1, arg_str2

! IARGC returns the total number of arguments on the
!   command line

 IF( arg_str1 == "ymd_mjd" ) THEN
   read(arg_str2,"(i8)") ymd
   CALL YMD_MJD( YMD, MJD )
   WRITE(6,"(I6)") MJD
 ELSE IF (arg_str1 == "mjd_ymd" ) THEN
   read(arg_str2,"(i6)") mjd
   CALL MJD_YMD( MJD, YMD )
   WRITE(6,"(I8)") YMD
 ELSE IF (arg_str1 == "ymdhms_mjdsec" ) THEN
   read(arg_str2,"(I8)") YMD
   read(arg_str3,"(F12.3)") HMS
   CALL YMDHMS_MJDSEC ( YMD, HMS, MJDSEC )
   WRITE(6,"(f20.3)") MJDSEC
 ELSE IF (arg_str1 == "ymdhms_mjdsec_fsec" ) THEN
   read(arg_str2,"(I8)") YMD
   read(arg_str3,"(F19.12)") HMS
   CALL YMDHMS_MJDSEC_FSEC ( YMD, HMS, MJDSEC, FSEC )
   WRITE(6,"(f20.1,1X,f15.12)") MJDSEC, FSEC
 ELSE IF (arg_str1 == "mjdsec_ymdhms" ) THEN
   read(arg_str2,"(F20.3)") mjdsec
   CALL MJDSEC_YMDHMS ( MJDSEC, YMD, HMS )
   WRITE(6,"(i8,1x,f12.3)") ymd,hms
 ELSE IF (arg_str1 == "mjdsec_fsec_ymdhms" ) THEN
   read(arg_str2,"(F20.1)") mjdsec
   read(arg_str3,"(F15.12)") fsec
   CALL MJDSEC_FSEC_YMDHMS ( MJDSEC, FSEC, YMD, HMS )
   WRITE(6,"(i8,1x,f19.12)") ymd,hms
 ELSE IF (arg_str1 == "mjdsec_fsec_add" ) THEN
   read(arg_str2,"(F20.1)") mjdsec_1
   read(arg_str3,"(F15.12)") fsec_1
   read(arg_str4,"(F20.1)") mjdsec_2
   read(arg_str5,"(F15.12)") fsec_2
   CALL MJDSEC_FSEC_ADD ( MJDSEC_1, FSEC_1, MJDSEC_2, FSEC_2, MJDSEC_SUM, FSEC_SUM )
   WRITE(6,"(F20.1,1x,f15.12)") mjdsec_sum, fsec_sum
 ELSE IF (arg_str1 == "mjd_doy" ) THEN
   read(arg_str2,"(i6)") mjd
   CALL MJD_DOY ( MJD, IY, IDOY )
   WRITE(6,"(I4,1X,I3)") IY, IDOY 
 ELSE IF (arg_str1 == "gpsweek_doy" ) THEN
   read(arg_str2,"(I4)") GPS_Week
   CALL GPSWEEK_DOY(GPS_Week, IY, IDOY)
   WRITE(6,"(I4,1X,I3)") IY, IDOY 
 ELSE IF (arg_str1 == "ymdhms_gpsweek" ) THEN
   read(arg_str2,"(I8,I6)") YMD, ihms
   HMS = ihms
   CALL YMDHMS_GPSWEEK(YMD,HMS,GPS_Week,Day_of_Week)
   WRITE(6,"(I4,1X,I1)") GPS_Week,Day_of_Week
 ELSE IF (arg_str1 == "yrdoy_gpsweek" ) THEN
   read(arg_str2,"(I7)") YrDoy
   CALL YRDOY_GPSWEEK(YrDoy,GPS_Week,Day_of_Week)
   WRITE(6,"(I4,1X,I1)") GPS_Week,Day_of_Week
 ELSE IF (arg_str1 == "doy_mjd" ) THEN
   read(arg_str2,"(I4)") IY
   read(arg_str3,"(I3)") IDOY
   CALL DOY_MJD ( IY, IDOY, MJD )
   WRITE(6,"(I6)") MJD
 ELSE
   WRITE(6,"('ERROR!!! DATE PROGRAM NOT ACCESSIBLE. MODIFY PROGRAM.')")
 END IF

END PROGRAM compute_date
