MODULE global_module 
!--------------------------------------------------------------------------
!
!  Module to define all global data, including all derived types.
!
!--------------------------------------------------------------------------

 USE kinds_mod

 IMPLICIT NONE

 INTEGER, PARAMETER :: Error_UnitNum = 2
 INTEGER, PARAMETER :: NEWBIH_UnitNum = 60
 INTEGER, PARAMETER :: OLDBIH_UnitNum = 12
 INTEGER, PARAMETER :: A1UTC_UnitNum = 13 
 INTEGER, PARAMETER :: POLE_Curr_UnitNum = 14 
 INTEGER, PARAMETER :: POLE_Pred_UnitNum = 15 
 INTEGER, PARAMETER :: FLUX_Prev_UnitNum = 16 
 INTEGER, PARAMETER :: FLUX_Curr_UnitNum = 17 
 INTEGER, PARAMETER :: DGD_UnitNum = 18 
 INTEGER, PARAMETER :: DSD_UnitNum = 19 
 INTEGER, PARAMETER :: DF45_UnitNum = 20 
 INTEGER, PARAMETER :: IONO_UnitNum = 21 
 INTEGER, PARAMETER :: Scratch_UnitNum = 30 
 INTEGER, PARAMETER :: Scratch2_UnitNum = 31 
 INTEGER, PARAMETER :: Scratch3_UnitNum = 32
 INTEGER, PARAMETER :: Scratch4_UnitNum = 33 
 INTEGER, PARAMETER :: Report_UnitNum = 40 
 INTEGER, PARAMETER :: Table_Unitnum = 41 
 INTEGER, PARAMETER :: mjd_010166 = 39126        ! used for a1utc to compute number of elapsed days
                                                 ! since Jan 1, 1966
 INTEGER(KIND=i4b), PARAMETER :: ymd_fluxkp8_start = 19660101  ! start of the fluxkp8 values, used for
                                                               ! computing index for updates
 INTEGER, PARAMETER :: num_kpap_table_values = 28
 INTEGER, PARAMETER :: iscale_flag = 2           ! flag indicating pole values are in micro_arcseconds
 INTEGER :: OpenStatus, InputStatus, AllocStatus

 INTEGER(KIND=i4b), PARAMETER :: nlines_per_month = 3
 INTEGER(KIND=i4b), PARAMETER :: tot_days = 144          ! 4 months x 36 days
                                                         ! 30 days est + 45 days pred cover ~ 4 m

 CHARACTER(*), PARAMETER :: old_bih_file = "master_bih.table"
 CHARACTER(*), PARAMETER :: new_bih_file = "master_bih.table_new"
 CHARACTER(*), PARAMETER :: report_file = "master_bih_update.report"
 CHARACTER(*), PARAMETER :: utctai_file = "UTC-TAI.history"
 !CHARACTER(*), PARAMETER :: pole_curr_file = "eopc04.62-now"
 !CHARACTER(*), PARAMETER :: pole_pred_file = "ser7.dat"
 CHARACTER(*), PARAMETER :: pole_curr_file = "eopc04_IAU2000.62-now"
 CHARACTER(*), PARAMETER :: pole_pred_file = "finals2000A.daily"
 CHARACTER(*), PARAMETER :: dgd_file = "DGD.txt"
 CHARACTER(*), PARAMETER :: dsd_file = "DSD.txt"
 CHARACTER(*), PARAMETER :: df45_file = "45DF.txt"
 CHARACTER(*), PARAMETER :: iono_file = "ig_rz.dat"
 CHARACTER(*), PARAMETER :: table_file = "a1utc.table"
 CHARACTER(5), DIMENSION(12), PARAMETER :: months_5 = (/"Jan. ","Feb. ","March","April","May  ","Jun. ", &
                                                        "Jul. ","Aug. ","Sept.","Oct. ","Nov. ","Dec. "/) 
 CHARACTER(5), DIMENSION(12), PARAMETER :: months_5_1 = (/"Jan  ","Feb  ","March","April","May  ","Jun  ", &
                                                        "Jul  ","Aug  ","Sept ","Oct  ","Nov  ","Dec  "/) 
 !CHARACTER(3), DIMENSION(12), PARAMETER :: months_3 = (/"JAN","FEB","MAR","APR","MAY","JUN", &
 !                                                       "JUL","AUG","SEP","OCT","NOV","DEC"/) 
 CHARACTER(3), DIMENSION(12), PARAMETER :: months_3 = (/"Jan","Feb","Mar","Apr","May","Jun", &
                                                        "Jul","Aug","Sep","Oct","Nov","Dec"/) 


 CHARACTER(7), DIMENSION(6), PARAMETER :: bih_sections = &
                                        (/"A1UTC  ","POLE   ","FLUXS  ","FLUXAP ","FLUXKP8","IONIND "/)

 REAL(KIND = r8b), DIMENSION(num_kpap_table_values), PARAMETER :: kp_table_values =       &
                                           (/ 0.00, 0.33, 0.66, 1.00, 1.33, 1.66, 2.00,   &
                                              2.33, 2.66, 3.00, 3.33, 3.66, 4.00, 4.33,   &
                                              4.66, 5.00, 5.33, 5.66, 6.00, 6.33, 6.66,   &
                                              7.00, 7.33, 7.66, 8.00, 8.33, 8.66, 8.99 /) 

 REAL(KIND = r8b), DIMENSION(num_kpap_table_values), PARAMETER :: ap_table_values =            &
                                           (/  0.0,   2.0,   3.0,   4.0,   5.0,   6.0,   7.0,  &
                                               9.0,  12.0,  15.0,  18.0,  22.0,  27.0,  32.0,  &
                                              39.0,  48.0,  56.0,  67.0,  80.0,  94.0, 111.0,  &
                                             132.0, 154.0, 179.0, 207.0, 236.0, 300.0, 400.0 /) 

 REAL(KIND = r8b), PARAMETER :: Zero = 0.0_r8b
 REAL(KIND = r8b), PARAMETER :: A1TAI = 0.034381700_r8b
 REAL(KIND = r8b), PARAMETER :: secs_per_day = 86400.0_r8b
 REAL(KIND=r8b), PARAMETER :: ScaleM3 = 0.001_r8b
 REAL(KIND=r8b), PARAMETER :: ScaleD4 = 10000.0_r8b
 REAL(KIND=r8b), PARAMETER :: ScaleD6 = 1000000.0_r8b
 REAL(KIND=r8b), PARAMETER :: MJD_2_JD = 2400000.5_r8b
 REAL(KIND=r8b), PARAMETER :: Version = 200109.0_r8b


END MODULE global_module
